/*
 * usart.c
 *
 * Created: 01.03.2012 14:46:57
 *  Author: Dr_Welt
 */ 

#include "usart.h"
#include <avr/io.h>


void USART_Init(  unsigned int baud )
{
	/*  Set baud rate  */
	UBRRH = (unsigned char )(baud>>8);
	UBRRL = (unsigned char )baud;
	/*  Enable receiver and transmitter  */
	UCSRB = (1<<RXEN)|(1<<TXEN);
	/*  Set frame format: 8data, 2stop bit */
	UCSRC = (1<<URSEL)|(3<<UCSZ0);
}

unsigned char  USART_Receive(  void )
{
	/*  Wait for data to be received  */
	while ( !(UCSRA & (1<<RXC)) );
	/*  Get and return received data from buffer */
	return  UDR;
}

void USART_Transmit( unsigned char  data )
{
	/*  Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) );
	/*  Put data into buffer, sends the data  */
	UDR = data;
}
void SendString( char* data )
{
	while (*data) USART_Transmit(*data++);
}

void uart_puthex_nibble(const unsigned char b)
{
    unsigned char  c = b & 0x0f;
    if (c>9) c += 'A'-10;
    else c += '0';
    USART_Transmit(c);
} /* uart_puthex_nibble */

void uart_puthex_byte(const unsigned char  b)
{
    uart_puthex_nibble(b>>4);
    uart_puthex_nibble(b);
} /* uart_puthex_byte */

void uart_puti( const int val )
{
    // char buffer[sizeof(int)*8+1];
    
    // SendString( itoa(val, buffer, 10) );

}/* uart_puti */
